// File: list.cpp

#include <iostream>
#include <cstdlib>
using namespace std;

#include "list.h"

List::List() : top(0)
{ }

List::~List()
{
    Node* temp = top;
    while (temp != nullptr)
    {
        top = top -> get_next();
        delete temp;
        temp = top;
    }
}

void List::push(int item)
{
    Node* temp = new Node(item,top);
    top = temp;
}

int List::pop()
{
    Node* temp = top;
    top = top->get_next();
    int value = temp->get_data();
    delete temp;
    return value;
}

Node* List::get_top() const
{
    return top;
}

Node*	List::find(int item) const
{
    Node* temp = top;
    while (temp != 0)
    {
        if (temp->get_data() == item) return temp;
        temp = temp -> get_next();
    }
    return 0;
}

bool List::remove(int item)
{
    if (!find(item))
    {
        cerr << item << " is not in the List\n";
        return false;
    }
    Node* temp1 = top;
    Node* temp2;
    if (top->get_data() == item)
    {
        top = top -> get_next();
        delete temp1;
        return true;
    }
    while (temp1->get_next()->get_data() != item)
    {
        temp1 = temp1 -> get_next();
    }
    temp2 = temp1 -> get_next();
    temp1->set_next(temp2->get_next());
    delete temp2;
    return true;
}

ostream& operator<<(ostream& out, const List& object)
{
    Node* temp = object.get_top();
    while (temp != 0)
    {
        out << *temp << ' ';
        temp = temp -> get_next();
    }
    return out;
}
